;UCART SYSOP 2.8
;By Wegi, menu by MCbx (poor code!)
;2013 MCbx

;FILES DESCRIPTION:
; - sysop1 - Original Sysop by Mr. Wegi
; - sysop2 - main sysop2 development file. If works, do not touch
; - sysop2.4 - sysop2 with 4 programs support
; - sysop2.8 - sysop2 with 8 programs support
; - sysop3 - sysop2 with partition extension.
; - sysop3.2 - sysop3 with 2 partition extension (27C010) - 128K total disk
; - sysop3.4 - sysop3 with 4 partition extension (27C020) - 256K total disk
; - sysop3.8 - sysop3 with 8 partition extension (27C040) - 512K total disk

;HW BRIEF DESCRIPTION:
; - After powerup/reset it sees first bank of ROM
; - Each click (STA $DE00) changes to next ROM bank
; - Last click turns cart visibility off, now it can be clicked and nothing 
;   will happen, cart will stay invisible.

;FUTURE UPGRADE
; - Use IO2 port and address lines to address 3 more lines in 27C010/020/040 
;   EPROM. This will make up to 8 64K partitions for programs.
;    (see Black Box 8 schematic for details how to connect this thing)
; - SYSOP must carry to screen 2 bytes for addressing: partition and start bank.


         *= $8000
         BYTE <COLD
         BYTE >COLD
         BYTE <COLD
         BYTE >COLD
         BYTE $C3,$C2,$CD,$38,$30

COLD
         SEI
         CLD
         LDX #$FF
         TXS
         LDA #$37
         STA $01

         STX $D016
         JSR $FDA3
         LDA #$00
         TAX
         TAY

LP1
         STA $02,Y
         STA $0200,Y
         STA $0300,Y
         INY
         BNE LP1
         LDY #$A0

         STY $C2
         STA $C1

         JSR $FE2D
         JSR $FD90
         JSR $FD15
         JSR $FF5B
         JSR $E453
         JSR $E3BF
         JSR $A644    
         SEI
         LDX #$FB
         TXS            ;computer initialization

         LDA #<DANE     ;cart data pointer in $FC $FB memory
         STA $FB
         LDA #>DANE
         STA $FC

         LDA #$01       ;destination memory address in $FE $FD memory
         STA $FD
         LDA #$08
         STA $FE       ;we start as in all BASIC programs

;--MENU START--
       ;   JSR          $E544                    ;clear screen          
          LDA          #$00            ;black border
          STA          $D020          ;set it
          LDA          #$08            ; bckground         
          STA          $D021          ;set it

          LDY          #>NAGL          
          LDA          #<NAGL          
          JSR          $AB1E                    ;write menu                  

          LDA          #$07          ;green text
     ;    LDX          #0          
LTC       STA          $d800,X
          STA          $d900,X          
          inx
          bne          LTC

indata    JSR          $ffe4
          BEQ          indata           ;loop until keypress
          CMP          #$31     
          BEQ          L2A  ;posa          
          CMP          #$32     
          BEQ          LZ ;posb       
          CMP          #$33     
          BEQ          posc          
          CMP          #$34     
          BEQ          posd          
          CMP          #$35          
          BEQ          pose          
          CMP          #$36          
          BEQ          posf          
          CMP          #$37          
          BEQ          posg          
          CMP          #$38          
          BEQ          posh
          BNE          indata  

;posa      LDA          #$00 ;introduces values to $52 - unused cell
;          STA          $52 
;          LDY          #$00          
;          BEQ          L2     
;posb    ; LDA          #$00     ;8K banks count: 
        ; STA          $52      ;   OS - always first item
        ;  BPL          LZ       ;   1,2,3,4,5,6.
posc      LDA          #$01     
          STA          $52          
          BPL          LZ    
posd      LDA          #$02     
          STA          $52 
          BPL          LZ          
pose      LDA          #$03     
          STA          $52 
          BPL          LZ 
posf      LDA          #$04     
          STA          $52 
          BPL          LZ  
posg      LDA          #$05     
          STA          $52 
          BPL          LZ    
posh      LDA          #$06     
          STA          $52 
          BPL          LZ         

L2A      LDY    #$00
L2
         LDA ($FB),Y    ;1SZE 8KB
         STA ($FD),Y
         INY
         BNE L2

         INC $D020
         INC $FC
         INC $FE
         LDA $FC
         CMP #$A0
         BCC L2
         LDA $FD
         SEC
         SBC #<DANE
         STA $FD
         LDA $FE
         SBC #$00
         STA $FE   ;CIAG DALSZY W RAM

LZ       LDY #$00
L3   ;COPY REST OF CODE TO SCREEN MEM AND RUN IT, CART MAY BE CLICKED FROM NOW
         LDA CLIK,Y
         STA $0400,Y
         INY
         BNE L3
         STY          $FB                    ;zeruj FB
         SEI
     
          
         JMP $0400  ;CONT NA EKRAN

;---EXECUTES IN COMPUTER RAM, NOT CART ROM
CLIK      
           LDA          $52          
           BEQ          PRP1          
           DEC          $52          
           STA          $DE00  ;CLICK      
           BNE          CLIK
PRP1
         STA $DE00  ;NEX 8KB
         LDA #$80
         STA $FC   ;FC=80 - start dump location in cart mem
PRP2     
         LDA ($FB),Y
         INC $01
         STA ($FD),Y
         DEC $01
         INY 
         BNE PRP2
         INC $D020
         INC $FC
         INC $FE
         LDA $FE
         CMP #$FF
         BEQ PRP3
         LDA $FC
         CMP #$A0
         BNE PRP2
         BEQ PRP1

PRP3

         STA $DE00  ;8MY CLICK
                         ;CART OFF
       ; CLI
       
          
         JSR $A659
         JMP $A7AE  ;RUN
;--------
NAGL      BYTE $0d
     TEXT "    SYSOP VER. 2.16"
          BYTE $0d 
          BYTE $0d
     TEXT " 1. PROGRAM NUMER 1"
          BYTE $0d
     TEXT " 2. PROGRAM NUMER 2"
          BYTE $0d
     TEXT " 3. PROGRAM NUMER 3"
          BYTE $0d
     TEXT " 4. PROGRAM NUMER 4"
          BYTE $0d
     TEXT " 5. PROGRAM NUMER 5"
          BYTE $0d
     TEXT " 6. PROGRAM NUMER 6"
          BYTE $0d
     TEXT " 7. PROGRAM NUMER 7"          
          BYTE $0d
     TEXT " 8. PROGRAM NUMER 8"
          BYTE $00
DANE
       
         ;NASZA  GRA URUCHAMIANA
        ;1SZA LINIA BASIC

