;UCART SYSOP 2.16
;By Wegi, broken by MCbx (poor code!)
;2013 MCbx
;CRUDE HACK IMPLEMENTED TO GET ONE MORE ADDR LINE

;FILES DESCRIPTION:
; - sysop1 - Original Sysop by Mr. Wegi
; - sysop2.8 - sysop2 with 8 programs support
; - sysop216 - This file :)

;HW BRIEF DESCRIPTION:
; - After powerup/reset it sees first bank of ROM
; - Each click (STA $DE00) changes to next ROM bank
; - Last click turns cart visibility off, now it can be clicked and nothing 
;   will happen, cart will stay invisible.


;CRUDE HACK EXPLAINATION:
; We use 7493 instead of 7490.
; 4th line of counter is used to drive additional addr line.
; So after reaching 1111 we click back to 0000.
; Click locker and EXROM locker are implemented with 74LS00 configured
;  as RS latch, driven from IO2, as can be seen in Black Box 3 cartridge.
;
; WE MUST REMEMBER ABOUT TURNING CART OFF AFTER COPYING!
;  CMP $DF00 or other operation on DF00. This will shut it down until reset.


         *= $8000
         BYTE <COLD
         BYTE >COLD
         BYTE <COLD
         BYTE >COLD
         BYTE $C3,$C2,$CD,$38,$30

COLD
         SEI
         CLD
         LDX #$FF
         TXS
         LDA #$37
         STA $01

         STX $D016
         JSR $FDA3
         LDA #$00
         TAX
         TAY

LP1
         STA $02,Y
         STA $0200,Y
         STA $0300,Y
         INY
         BNE LP1
         LDY #$A0

         STY $C2
         STA $C1

         JSR $FE2D
         JSR $FD90
         JSR $FD15
         JSR $FF5B
         JSR $E453
         JSR $E3BF
         JSR $A644    
         SEI
         LDX #$FB
         TXS            ;computer initialization

         LDA #<DANE     ;cart data pointer in $FC $FB memory
         STA $FB
         LDA #>DANE
         STA $FC

         LDA #$01       ;destination memory address in $FE $FD memory
         STA $FD
         LDA #$08
         STA $FE       ;we start as in all BASIC programs

;--MENU START--
          LDA          #$00            ;black border
          STA          $D020          ;set it
          LDA          #$08            ; bckground         
          STA          $D021          ;set it

          LDY          #>NAGL          
          LDA          #<NAGL          
          JSR          $AB1E                    ;write menu
          
          LDA          #$07          ;green text
 LTC       STA          $d800,X
          STA          $d900,X          
          STA          $dA00,X   
          inx
          bne          LTC

indata    JSR          $ffe4
          BEQ          indata           ;loop until keypress
          CMP          #$33       ;---BANK 2!
          BEQ          posc          
          CMP          #$34       ;--BANK 3!
          BEQ          posd          
          CMP          #$35       ;--BANK 4!   
          BEQ          pose          
          CMP          #$36       ;--BANK 5!   
          BEQ          posf          
          CMP          #$37       ;--BANK 6!   
          BEQ          posg          
          CMP          #$38       ;--BANK 7!   
          BEQ          posh
          CMP          #$39       ;--BANK 8!   
          BEQ          posi
          CMP          #$30       ;--BANK 9!   
          BEQ          posj
          CMP          #$41       ;--BANK A!   
          BEQ          posk
          CMP          #$42       ;--BANK B!   
          BEQ          posl
          CMP          #$43       ;--BANK C!   
          BEQ          posm
          CMP          #$44       ;--BANK D!   
          BEQ          posn
          CMP          #$45       ;--BANK E!   
          BEQ          poso
          CMP          #$46       ;--BANK F!    
          BEQ          posp
          CMP          #$31      ;--BANK 0!!!!!!!
          BEQ          L2A
          CMP          #$32      ;---BANK 1!
          BEQ          LZ     ;order screwed for platform compatibility reasons
          BNE          indata

posc      LDA          #$01     
          STA          $52          
          BPL          LZ    
posd      LDA          #$02     
          STA          $52 
          BPL          LZ          
pose      LDA          #$03     
          STA          $52 
          BPL          LZ 
posf      LDA          #$04     
          STA          $52 
          BPL          LZ  
posg      LDA          #$05     
          STA          $52 
          BPL          LZ    
posh      LDA          #$06     
          STA          $52 
          BPL          LZ     ;8
posi      LDA          #$07     
          STA          $52 
          BPL          LZ  
posj      LDA          #$08     
          STA          $52 
          BPL          LZ    
posk      LDA          #$09     
          STA          $52 
          BPL          LZ    
posl      LDA          #$0A     
          STA          $52 
          BPL          LZ    
posm      LDA          #$0B     
          STA          $52 
          BPL          LZ
posn      LDA          #$0C     
          STA          $52 
          BPL          LZ    
poso      LDA          #$0D     
          STA          $52 
          BPL          LZ 
posp      LDA          #$0E     
          STA          $52 
          BPL          LZ             
        
L2A      LDY    #$00
L2
         LDA ($FB),Y    ;1ST 8KB
         STA ($FD),Y
         INY
         BNE L2

         INC $D020
         INC $FC
         INC $FE
         LDA $FC
         CMP #$A0
         BCC L2
         LDA $FD
         SEC
         SBC #<DANE
         STA $FD
         LDA $FE
         SBC #$00
         STA $FE   ;COPY NEXT IN RAM

LZ       LDY #$00
L3   ;COPY REST OF CODE TO SCREEN MEM AND RUN IT, CART MAY BE CLICKED FROM NOW
         LDA CLIK,Y
         STA $0400,Y
         INY
         BNE L3
         STY          $FB                    ;zeruj FB
         SEI
     
          
         JMP $0400  ;RUN NEXT IN RAM

;---EXECUTES IN COMPUTER RAM, NOT CART ROM
CLIK      
           LDA          $52          
           BEQ          PRP1          
           DEC          $52          
           STA          $DE00  ;CLICK      
           BNE          CLIK
PRP1
         STA $DE00  ;NEX 8KB
         LDA #$80
         STA $FC   ;FC=80 - start dump location in cart mem
PRP2     
         LDA ($FB),Y
         INC $01
         STA ($FD),Y
         DEC $01
         INY 
         BNE PRP2
         INC $D020
         INC $FC
         INC $FE
         LDA $FE
         CMP #$FF
         BEQ PRP3
         LDA $FC
         CMP #$A0
         BNE PRP2
         BEQ PRP1

PRP3

       ;  STA $DE00  ;8MY CLICK
                         ;CART OFF
          STA   $DF00 ;Cart OFF - crudehack
       ; CLI
       
          
         JSR $A659
         JMP $A7AE  ;RUN!
;--------
NAGL      BYTE $0d
          BYTE $0d 
     TEXT "    SYSOP VER. 2.16 "
          BYTE $0d 
          BYTE $0d
     TEXT " 1. PROGRAM NUMER 1 "
          BYTE $0d
     TEXT " 2. PROGRAM NUMER 2 "
          BYTE $0d
     TEXT " 3. PROGRAM NUMER 3 "
          BYTE $0d
     TEXT " 4. PROGRAM NUMER 4 "
          BYTE $0d
     TEXT " 5. PROGRAM NUMER 5 "
          BYTE $0d
     TEXT " 6. PROGRAM NUMER 6 "
          BYTE $0d
     TEXT " 7. PROGRAM NUMER 7 "          
          BYTE $0d
     TEXT " 8. PROGRAM NUMER 8 "
          BYTE $0d
     TEXT " 9. PROGRAM NUMER 9 "
          BYTE $0d
     TEXT " 0. PROGRAM NUMER 0 "
          BYTE $0d
     TEXT " A. PROGRAM NUMER A "
          BYTE $0d
          BYTE $00
DANE
       
